Index: tests/GuiChecks/Potential/FitPotential/testsuite-potential-fit-potential.at
===================================================================
--- tests/GuiChecks/Potential/FitPotential/testsuite-potential-fit-potential.at	(revision dd6c07d2c5d563c8e46c0a4b01a0de11563eb584)
+++ tests/GuiChecks/Potential/FitPotential/testsuite-potential-fit-potential.at	(revision dd6c07d2c5d563c8e46c0a4b01a0de11563eb584)
@@ -0,0 +1,171 @@
+#
+#    MoleCuilder - creates and alters molecular systems
+#    Copyright (C) 2013 University of Bonn
+#    Copyright (C) 2013 Frederik Heber
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU General Public License as published by
+#    the Free Software Foundation, either version 3 of the License, or
+#    (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU General Public License for more details.
+#
+#    You should have received a copy of the GNU General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+### fit some potentials
+
+AT_SETUP([Potential - Fit morse potential to water])
+AT_KEYWORDS([potential parse-homologies fit-potential morse])
+AT_SKIP_IF([../../molecuilder --help fit-potential; if test $? -eq 5; then /bin/true; else /bin/false; fi])
+
+file=length_homology.dat
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Potential/FitPotential/pre/$file $file], 0)
+AT_CHECK([chmod u+w $file], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilder \
+	--parse-homologies $file \
+	--set-random-number-engine "lagged_fibonacci607" \
+		--random-number-engine-parameters "seed=1;" \
+	--set-random-number-distribution "uniform_real" \
+		--random-number-distribution-parameters "min=0;max=1;" \
+	--fit-potential \
+		--potential-type "morse" \
+		--potential-charges 8 1 \
+		--fragment-charges 1 8 1 \
+		--set-threshold 1e-6 \
+	--save-potentials length.potentials], 0, [stdout], [ignore])
+# check that L_2 error is below 1e-6
+# check parameters to printed precision
+AT_CHECK([grep "morse:.*particle_type1=8,.*particle_type2=1,.*spring_constant=1.27.*,.*equilibrium_distance=1.78.*,.*dissociation_energy=0.19.*;" length.potentials], 0, [ignore], [ignore])
+
+AT_CLEANUP
+
+AT_SETUP([Potential - Fit harmonic potential to water])
+AT_KEYWORDS([potential parse-homologies fit-potential harmonic])
+AT_SKIP_IF([../../molecuilder --help fit-potential; if test $? -eq 5; then /bin/true; else /bin/false; fi])
+
+file=harmonic_homology.dat
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Potential/FitPotential/pre/$file $file], 0)
+AT_CHECK([chmod u+w $file], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilder \
+	--parse-homologies $file \
+	--set-random-number-engine "lagged_fibonacci607" \
+		--random-number-engine-parameters "seed=1;" \
+	--set-random-number-distribution "uniform_real" \
+		--random-number-distribution-parameters "min=0;max=1;" \
+	--fit-potential \
+		--potential-type "harmonic_bond" \
+		--potential-charges 8 1 \
+		--fragment-charges 1 8 1 \
+		--set-threshold 1e-6 \
+	--save-potentials harmonic.potentials], 0, [stdout], [ignore])
+# check that L_2 error is below 1e-6
+# check parameters to printed precision
+AT_CHECK([grep "harmonic_bond:.*particle_type1=8,.*particle_type2=1,.*spring_constant=0.29.*,.*equilibrium_distance=1.8.*;" harmonic.potentials], 0, [ignore], [ignore])
+
+AT_CLEANUP
+
+AT_SETUP([Potential - Fit harmonic_angle potential to water])
+AT_KEYWORDS([potential parse-homologies fit-potential harmonic_angle])
+AT_SKIP_IF([../../molecuilder --help fit-potential; if test $? -eq 5; then /bin/true; else /bin/false; fi])
+
+file=angle_homology.dat
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Potential/FitPotential/pre/$file $file], 0)
+AT_CHECK([chmod u+w $file], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilder \
+	--parse-homologies $file \
+	--set-random-number-engine "lagged_fibonacci607" \
+		--random-number-engine-parameters "seed=1;" \
+	--set-random-number-distribution "uniform_real" \
+		--random-number-distribution-parameters "min=0;max=1;" \
+	--fit-potential \
+		--potential-type "harmonic_angle" \
+		--potential-charges 1 8 1 \
+		--fragment-charges 1 8 1 \
+		--set-threshold 1e-6 \
+	--save-potentials angle.potentials], 0, [stdout], [ignore])
+# check that L_2 error is below 1e-6
+# check parameters to printed precision
+AT_CHECK([grep "harmonic_angle:.*particle_type1=1,.*particle_type2=8,.*particle_type3=1,.*spring_constant=0.10.*,.*equilibrium_distance=-0.27.*;" angle.potentials], 0, [ignore], [ignore])
+
+AT_CLEANUP
+
+AT_SETUP([Potential - Fit torsion potential to butane])
+AT_KEYWORDS([potential parse-homologies fit-potential torsion])
+AT_SKIP_IF([../../molecuilder --help fit-potential; if test $? -eq 5; then /bin/true; else /bin/false; fi])
+
+file=torsion_homology.dat
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Potential/FitPotential/pre/$file $file], 0)
+AT_CHECK([chmod u+w $file], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilder \
+	--parse-homologies $file \
+	--set-random-number-engine "lagged_fibonacci607" \
+		--random-number-engine-parameters "seed=1;" \
+	--set-random-number-distribution "uniform_real" \
+		--random-number-distribution-parameters "min=0;max=1;" \
+	--fit-potential \
+		--potential-type "torsion" \
+		--potential-charges 6 6 6 6 \
+		--fragment-charges 6 6 6 6 1 1 1 1 1 1 1 1 1 1 \
+		--set-threshold 2e-10 \
+	--save-potentials torsion.potentials], 0, [stdout], [ignore])
+# check that L_2 error is below 9e-12 ... just 2e-10 otherwise test takes tooo long
+AT_CHECK([grep "torsion:.*particle_type1=6,.*particle_type2=6,.*particle_type3=6,.*particle_type4=6,.*spring_constant=.*,.*equilibrium_distance=.*;" torsion.potentials], 0, [ignore], [ignore])
+#AT_CHECK([grep "torsion:.*particle_type1=6,.*particle_type2=6,.*particle_type3=6,.*particle_type4=6,.*spring_constant=0.001.*,.*equilibrium_distance=0.99.*;" torsion.potentials], 0, [ignore], [ignore])
+
+AT_CLEANUP
+
+AT_SETUP([Potential - Fit improper potential to ammonia])
+AT_KEYWORDS([potential parse-homologies fit-potential improper])
+AT_SKIP_IF([../../molecuilder --help fit-potential; if test $? -eq 5; then /bin/true; else /bin/false; fi])
+
+file=improper_homology.dat
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Potential/FitPotential/pre/$file $file], 0)
+AT_CHECK([chmod u+w $file], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilder \
+	--parse-homologies $file \
+	--set-random-number-engine "lagged_fibonacci607" \
+		--random-number-engine-parameters "seed=1;" \
+	--set-random-number-distribution "uniform_real" \
+		--random-number-distribution-parameters "min=0;max=1;" \
+	--fit-potential \
+		--potential-type "improper" \
+		--potential-charges 1 7 1 1 \
+		--fragment-charges 7 1 1 1 \
+		--set-threshold 3e-4 \
+	--save-potentials improper.potentials], 0, [stdout], [ignore])
+# check that L_2 error is below 3e-4
+# check parameters to printed precision
+AT_CHECK([grep "improper:.*particle_type1=1,.*particle_type2=7,.*particle_type3=1,.*particle_type4=1,.*spring_constant=.*,.*equilibrium_distance=.*;" improper.potentials], 0, [ignore], [ignore])
+#AT_CHECK([grep "improper:.*particle_type1=1,.*particle_type2=7,.*particle_type3=1,.*particle_type4=1,.*spring_constant=1.02.*,.*equilibrium_distance=0.85.*;" improper.potentials], 0, [ignore], [ignore])
+
+AT_CLEANUP
+
+AT_SETUP([Potential - Fit LJ potential to argon])
+AT_KEYWORDS([potential parse-homologies fit-potential lennardjones])
+AT_SKIP_IF([../../molecuilder --help fit-potential; if test $? -eq 5; then /bin/true; else /bin/false; fi])
+
+file=lj_homology.dat
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Potential/FitPotential/pre/$file $file], 0)
+AT_CHECK([chmod u+w $file], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilder \
+	--parse-homologies $file \
+	--set-random-number-engine "lagged_fibonacci607" \
+		--random-number-engine-parameters "seed=5;" \
+	--set-random-number-distribution "uniform_real" \
+		--random-number-distribution-parameters "min=0;max=1;" \
+	--fit-potential \
+		--potential-type "lennardjones" \
+		--potential-charges 18 18 \
+		--fragment-charges 18 18 \
+		--set-threshold 7e-9 \
+	--save-potentials lj.potentials], 0, [stdout], [ignore])
+# check that L_2 error is below 7e-11 ... just 7e-9 otherwise test takes too long
+# check parameters to printed precision
+AT_CHECK([grep "lennardjones:.*particle_type1=18,.*particle_type2=18,.*epsilon=.*,.*sigma=.*;" lj.potentials], 0, [ignore], [ignore])
+#AT_CHECK([grep "lennardjones:.*particle_type1=18,.*particle_type2=18,.*epsilon=1.*e-05,.*sigma=8.2.*;" lj.potentials], 0, [ignore], [ignore])
+
+AT_CLEANUP
